# TIDY-CLI Development howto

## Prerequisites for development

* Node (v6+) - https://nodejs.org/en/download/
* Tidy3 local development env (see repo: tidy-cms)
* Yarn - https://yarnpkg.com/lang/en/docs/install/

## Installing local development

`cd /data/tidy3/`

`git@bitbucket.org:tidycms/tidy-cli.git`

`cd tidy-cli`

`yarn install`

## Development commands

```
# show help for cli
node ./src/cli.js

# show help for command
node ./src/cli.js [command] --help

# interactive auth
node ./src/cli.js login

# inline auth
node ./src/cli.js create-sites -e -u pyry@tidycms.com -p foobar

# list teams
node ./src/cli.js teams -o testing/teams.json

# list team sites
node ./src/cli.js sites -t clitest -o testing/sites.json

# list create site example
node ./src/cli.js create-sites -e -u pyry@tidycms.com -p foobar -o testing/create-site-example.json

# create sites

```

## Install local dev version to global node_modules

`./tidy-update-dev-cli.sh`
