#!/usr/bin/env node
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 7);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("lodash");

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Promise) {

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _ = __webpack_require__(0);
var fs = __webpack_require__(4);
var path = __webpack_require__(13);
var userHome = __webpack_require__(15);
var mkdirp = __webpack_require__(12);

var Utils = function () {
  function Utils() {
    _classCallCheck(this, Utils);
  }

  _createClass(Utils, null, [{
    key: 'readProfile',
    value: function readProfile() {
      if (!Utils.hasProfileFile) {
        return null;
      }
      try {
        var profileJson = fs.readFileSync(Utils.profileFile);
        return JSON.parse(profileJson);
      } catch (err) {
        throw new Error('Parsing of your ~/.tidycms JSON file failed:\n' + err.message);
      }
    }
  }, {
    key: 'updateProfile',
    value: function updateProfile(profileObject) {

      var profile = {};
      if (Utils.hasProfileFile) {
        profile = Utils.readProfile();
      }
      profile = _.merge(profile, profileObject);
      fs.writeFileSync(Utils.profileFile, JSON.stringify(profile, null, 2), {
        encoding: 'utf-8',
        mode: 384
      });
      return true;
    }
  }, {
    key: 'clearAuth',
    value: function clearAuth() {
      var profile = Utils.readProfile();
      if (!profile) {
        return false;
      }
      if (profile.id) {
        delete profile.id;
      }
      if (profile.token) {
        delete profile.token;
      }

      if (!_.isEmpty(profile)) {
        fs.writeFileSync(Utils.profileFile, JSON.stringify(profile, null, 2), {
          encoding: 'utf-8',
          mode: '0o600'
        });
      } else {
        fs.unlinkSync(Utils.profileFile);
      }
      return true;
    }
  }, {
    key: 'writeOutput',
    value: function writeOutput(data, filepath) {

      return new Promise(function (resolve, reject) {

        var curdir = process.cwd();
        var fullpath = path.resolve(curdir, filepath);
        var parts = path.parse(fullpath);

        mkdirp(parts.dir, function (err) {
          if (err) {
            return reject(err);
          }
          fs.writeFileSync(fullpath, JSON.stringify(data, null, 2), 'utf-8');
          resolve();
        });
      });
    }
  }, {
    key: 'readJsonFile',
    value: function readJsonFile(filepath) {

      return new Promise(function (resolve, reject) {

        if (!fs.existsSync(filepath)) {
          return reject(new Error('File does not exist: ' + filepath));
        }
        var json = fs.readFileSync(filepath);
        resolve(JSON.parse(json));
      });
    }
  }, {
    key: 'profileFile',
    get: function get() {
      return userHome + '/.tidycms';
    }
  }, {
    key: 'hasProfileFile',
    get: function get() {
      return fs.existsSync(Utils.profileFile);
    }
  }, {
    key: 'hasProfileCredentials',
    get: function get() {
      if (!Utils.hasProfileFile) {
        return false;
      }
      var profile = Utils.readProfile();
      return profile.email && profile.password;
    }
  }, {
    key: 'profileUmaskOk',
    get: function get() {
      if (!Utils.hasProfileFile) {
        return true;
      }
      var stats = fs.statSync(Utils.profileFile);
      return _.endsWith(stats.mode.toString(8), '00');
    }
  }]);

  return Utils;
}();

module.exports = Utils;
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2)))

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("bluebird");

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _ = __webpack_require__(0);
var util = __webpack_require__(16);
var Utils = __webpack_require__(1);

var TidyLogger = function () {
  function TidyLogger() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$verbose = _ref.verbose,
        verbose = _ref$verbose === undefined ? true : _ref$verbose;

    _classCallCheck(this, TidyLogger);

    this.verbose = verbose;
  }

  _createClass(TidyLogger, [{
    key: 'quiet',
    value: function quiet() {
      this.verbose = false;
    }
  }, {
    key: 'log',
    value: function log() {
      var me = this;
      if (arguments.length >= 1 && arguments.length <= 2 && (_.isObject(arguments[0]) || _.isArray(arguments[0]))) {
        var dirConfig = { colors: true };
        if (_.isObject(arguments[1])) {
          dirConfig = _.merge(dirConfig, arguments[1]);
        }
        if (me.verbose) {
          console.dir(arguments[0], dirConfig);
        }
      } else if (arguments[0] === 'error') {
        var _console;

        var messages = Array.prototype.slice.call(arguments, 1);
        (_console = console).log.apply(_console, ['\x1b[31m'].concat(_toConsumableArray(messages), ['\x1b[0m']));
      } else if (me.verbose) {
        var _console2;

        (_console2 = console).log.apply(_console2, arguments);
      }
    }
  }, {
    key: 'dir',
    value: function dir() {
      this.log.apply(this, arguments);
    }
  }, {
    key: 'error',
    value: function error() {
      this.log.apply(this, ['error'].concat(Array.prototype.slice.call(arguments)));
    }
  }, {
    key: 'exception',
    value: function exception(err) {
      var outputFile = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      this.log('--- ERROR: ' + err + ' ---');
      if (err.name === 'TidyApiError') {
        this.log(err);
      } else {
        this.log('error', err.message);
      }
      if (outputFile) {
        return Utils.writeOutput(util.inspect(err, { depth: null }), outputFile);
      }
    }
  }]);

  return TidyLogger;
}();

var logger = new TidyLogger();

module.exports = logger;

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("fs");

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Promise) {

// const Promise = require('bluebird')
// const get = require('simple-get')

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _ = __webpack_require__(0);
var inquirer = __webpack_require__(11);

var TidyRequest = __webpack_require__(10);
var Utils = __webpack_require__(1);
var logger = __webpack_require__(3);

var TidyCms = function () {
  function TidyCms() {
    _classCallCheck(this, TidyCms);
  }

  _createClass(TidyCms, null, [{
    key: 'loginCommand',
    value: function loginCommand(options) {
      TidyCms.login(options).catch(function (err) {
        logger.error('Login failed');
        logger.error(err.message);
      });
    }
  }, {
    key: 'login',
    value: function login(_ref) {
      var _ref$email = _ref.email,
          email = _ref$email === undefined ? null : _ref$email,
          _ref$password = _ref.password,
          password = _ref$password === undefined ? null : _ref$password;


      return new Promise(function (resolve, reject) {

        logger.log('Login to Tidy');

        var questions = [{
          type: 'input',
          message: 'Email:',
          name: 'email',
          validate: function validate(input) {
            var emailReg = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            if (input.match(emailReg)) {
              return true;
            }
            return 'Please enter a valid email address';
          }
        }, {
          type: 'password',
          message: 'Password:',
          name: 'password'
        }];

        var clearAuthentication = {
          email: email,
          password: password
        };

        TidyCms.readCredentials().then(function (credentials) {
          if (credentials) {
            return credentials;
          }
          var credentialPromise = void 0;
          if (clearAuthentication.email) {
            credentialPromise = Promise.resolve(null);
          } else {
            credentialPromise = inquirer.prompt(questions);
          }
          return credentialPromise;
        }).then(function (answers) {
          if (answers) {
            clearAuthentication = answers;
          }
          return TidyRequest.apiPost({
            uri: '/api/v1/oauth_get_token',
            form: clearAuthentication
          });
        }).then(function (authData) {

          if (_.hasIn(authData, 'success') && authData.success === false) {
            throw new Error(authData.message);
          }

          var authInfo = {
            id: authData.user.id,
            token: authData.access_token
          };
          Utils.updateProfile(authInfo);
          logger.log('Login successful: ', authData.user.firstname + ' ' + authData.user.lastname + ',', authData.user.email);

          resolve();
        }).catch(function (err) {
          reject(err);
        });
      });
    }
  }, {
    key: 'readCredentials',
    value: function readCredentials() {
      return new Promise(function (resolve, reject) {

        if (!Utils.profileUmaskOk) {

          // Possible values for process.platform are: 'darwin' (mac), 'freebsd', 'linux', 'sunos' or 'win32' (both x86 and 64)
          var isWin = process.platform.match(/^win/);

          if (!isWin) {
            var umaskError = 'Your profile file permissions are insecure.\nYou can fix this with command:\nchmod 0600 ~/.tidycms (linux/mac)';
            return reject(new Error(umaskError));
          }
        }

        if (!Utils.hasProfileFile) {
          return resolve(null);
        }

        var profile = Utils.readProfile();
        if (profile && profile.password && profile.email) {
          resolve({
            email: profile.email,
            password: profile.password
          });
        } else {
          resolve(null);
        }
      });
    }
  }, {
    key: 'preAuth',
    value: function preAuth(options) {
      return new Promise(function (resolve, reject) {
        var loginPromise = Promise.resolve();
        var profile = Utils.readProfile();
        if (!Utils.hasProfileFile || options.email && options.password || Utils.hasProfileCredentials && !profile.token) {
          loginPromise = TidyCms.login(options);
        }
        loginPromise.then(function () {
          resolve();
        }).catch(function (err) {
          reject(err);
        });
      });
    }
  }, {
    key: 'reAuth',
    value: function reAuth(options, callback) {

      options.email = null;
      options.password = null;
      Utils.clearAuth();
      return callback();
    }
  }, {
    key: 'teamsCommand',
    value: function teamsCommand(options) {

      return new Promise(function (resolve, reject) {

        TidyCms.preAuth(options).then(function () {
          return TidyRequest.cmsGet({ uri: '/api/cli/teams/list' });
        }).then(function (teams) {
          logger.log(teams);
          if (options.output) {
            return Utils.writeOutput(teams, options.output);
          }
        }).then(function () {
          if (options.output) {
            logger.log('output written to', options.output);
          }
          resolve();
        }).catch(function (err) {
          if (err.message && err.message === 'unauthorized') {
            return TidyCms.reAuth(options, function () {
              TidyCms.teamsCommand(options);
            });
          } else {
            reject(err);
          }
        });
      });
    }
  }, {
    key: 'sitesCommand',
    value: function sitesCommand(options) {

      return new Promise(function (resolve, reject) {

        if (!options.team) {
          return reject(new Error('Team domain option is required --team [tidy-team-domain]'));
        }

        TidyCms.preAuth(options).then(function () {
          return TidyRequest.cmsGet({ uri: '/api/cli/team/' + options.team + '/sites' });
        }).then(function (sites) {
          logger.log(sites);
          if (options.output) {
            return Utils.writeOutput(sites, options.output);
          }
        }).then(function () {
          if (options.output) {
            logger.log('output written to', options.output);
          }
          resolve();
        }).catch(function (err) {
          if (err.message && err.message === 'unauthorized') {
            return TidyCms.reAuth(options, function () {
              TidyCms.sitesCommand(options);
            });
          } else {
            reject(err);
          }
        });
      });
    }
  }, {
    key: 'sitesCreateCommand',
    value: function sitesCreateCommand(options) {

      if (options.example) {
        return TidyCms.sitesCreateOneExample(options);
      }
      if (options.multiple) {
        return TidyCms.sitesCreateMultipleExample(options);
      }

      return TidyCms.sitesCreateFromJson(options);
    }
  }, {
    key: 'sitesCreateFromJson',
    value: function sitesCreateFromJson(options) {

      return new Promise(function (resolve, reject) {

        var newSitePayload = void 0;
        Utils.readJsonFile(options.file).then(function (data) {
          newSitePayload = data;
          return TidyCms.preAuth(options);
        }).then(function () {
          return TidyRequest.cmsPost({
            uri: '/api/cli/sites/bulk/create',
            payload: newSitePayload
          });
        }).then(function (newSiteResponse) {
          logger.log(newSiteResponse);
          if (options.output) {
            return Utils.writeOutput(newSiteResponse, options.output);
          }
        }).then(function () {
          if (options.output) {
            logger.log('output written to', options.output);
          }
          resolve();
        }).catch(function (err) {
          if (err.message && err.message === 'unauthorized') {
            return TidyCms.reAuth(options, function () {
              TidyCms.sitesCreateFromJson(options);
            });
          } else {
            reject(err);
          }
        });
      });
    }
  }, {
    key: 'sitesCreateMultipleExample',
    value: function sitesCreateMultipleExample(options) {

      return new Promise(function (resolve, reject) {

        TidyRequest.cmsGet({ uri: '/api/example/create/sites.json', auth: false }).then(function (example) {
          logger.log(example, { depth: null });
          if (options.output) {
            return Utils.writeOutput(example, options.output);
          }
        }).then(function () {
          if (options.output) {
            logger.log('output written to', options.output);
          }
          resolve();
        }).catch(function (err) {
          if (err.message && err.message === 'unauthorized') {
            return TidyCms.reAuth(options, function () {
              TidyCms.sitesCreateMultipleExample(options);
            });
          } else {
            reject(err);
          }
        });
      });
    }
  }, {
    key: 'sitesCreateOneExample',
    value: function sitesCreateOneExample(options) {

      return new Promise(function (resolve, reject) {

        TidyCms.preAuth(options).then(function () {
          return TidyRequest.cmsGet({ uri: '/api/cli/example/create/onesite.json', auth: true });
        }).then(function (example) {
          logger.log(example, { depth: null });
          if (options.output) {
            return Utils.writeOutput(example, options.output);
          }
        }).then(function () {
          if (options.output) {
            logger.log('output written to', options.output);
          }
          resolve();
        }).catch(function (err) {
          if (err.message && err.message === 'unauthorized') {
            return TidyCms.reAuth(options, function () {
              TidyCms.sitesCreateOneExample(options);
            });
          } else {
            reject(err);
          }
        });
      });
    }
  }, {
    key: 'testCommand',
    value: function testCommand(options) {

      if (!options.output) {
        logger.error('output required');
        return;
      }

      var data = {
        foo: 'bar'
      };

      Utils.writeOutput(data, options.output).then(function () {
        logger.log('Done!');
      });
    }
  }]);

  return TidyCms;
}();

module.exports = TidyCms;
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(2)))

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("commander");

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var fs = __webpack_require__(4);
var program = __webpack_require__(6);

var packageJson = fs.readFileSync(__dirname + '/../package.json');
var packageInfo = JSON.parse(packageJson);

var logger = __webpack_require__(3);
var TidyCms = __webpack_require__(5);

program.version(packageInfo.version).option('-q, --quiet', 'do not output to console').option('-u, --user [email]', 'Tidy account email address (optional)').option('-p, --pass [password]', 'Account password (optional)').option('-c, --credentials [file]', 'Path to credentials file (optional)');
// .description('Tidy CMS command line utilities for site management')

program.command('login').description('Log in to Tidy').action(function (cmd) {
  if (program.quiet) {
    logger.quiet();
  }
  TidyCms.loginCommand({
    email: cmd.parent.user,
    password: cmd.parent.pass,
    credfile: cmd.parent.credentials
  });
});

program.command('teams').description('List teams your account has access').option('-o, --output [file]', 'Output results to file (optional)').action(function (cmd) {
  if (program.quiet) {
    logger.quiet();
  }
  TidyCms.teamsCommand({
    email: cmd.parent.user,
    password: cmd.parent.pass,
    credfile: cmd.parent.credentials,
    output: cmd.output
  }).catch(function (err) {
    logger.exception(err, cmd.output);
  });
});

program.command('sites').description('List sites for team').option('-t, --team [tidy-team-domain]', 'Your Tidy team domain (required)').option('-o, --output [file]', 'Output results to file (optional)').action(function (cmd) {
  if (program.quiet) {
    logger.quiet();
  }
  TidyCms.sitesCommand({
    email: cmd.parent.user,
    password: cmd.parent.pass,
    credfile: cmd.parent.credentials,
    output: cmd.output,
    team: cmd.team
  }).catch(function (err) {
    logger.exception(err, cmd.output);
  });
});

program.command('create-sites').description('Create one or multiple sites to team from json file').option('-e, --example', 'Show create one site example (optional)').option('-m, --multiple', 'Show example of create multiple sites JSON (optional)').option('-f, --file [filepath]', 'Create site JSON file (required)').option('-o, --output [file]', 'Output results to file (optional)').action(function (cmd) {
  if (program.quiet) {
    logger.quiet();
  }
  TidyCms.sitesCreateCommand({
    email: cmd.parent.user,
    password: cmd.parent.pass,
    credfile: cmd.parent.credentials,
    output: cmd.output,
    domain: cmd.domain,
    file: cmd.file,
    example: cmd.example,
    multiple: cmd.multiple
  }).catch(function (err) {
    logger.exception(err, cmd.output);
  });
});

// program
//   .command('test')
//   .description('Test command')
//   .option('-o, --output [file]', 'Output results to file')
//   .action((cmd) => {
//     TidyCms.testCommand({
//       output: cmd.output,
//     })
//       .catch((err) => {
//         program.outputHelp()
//         logger.error(err.message)
//       })
//   })

program.on('--help', function () {
  console.log('  Help for different commands can be accessed by:');
  console.log('');
  console.log('    $ ' + program._name + ' [command] --help');
  console.log('');
});

program.parse(process.argv);

if (program.args.length === 0) {
  program.help();
}

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var config = {
  server: {
    api: 'https://api.tidycms.site',
    cms: 'https://start.tidycms.site'
  }
};

module.exports = config;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TidyApiError = function (_Error) {
  _inherits(TidyApiError, _Error);

  function TidyApiError(message) {
    var trace = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    _classCallCheck(this, TidyApiError);

    var _this = _possibleConstructorReturn(this, (TidyApiError.__proto__ || Object.getPrototypeOf(TidyApiError)).call(this, message));

    _this.name = 'TidyApiError';
    _this.trace = trace;
    _this.status = 500;
    _this.stack = JSON.stringify(_this.trace);
    return _this;
  }

  return TidyApiError;
}(Error);

module.exports = TidyApiError;

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _ = __webpack_require__(0);
var Promise = __webpack_require__(2);
var get = __webpack_require__(14);

var config = __webpack_require__(8);
var Utils = __webpack_require__(1);
var ApiError = __webpack_require__(9);

var TidyRequest = function () {
  function TidyRequest() {
    _classCallCheck(this, TidyRequest);
  }

  _createClass(TidyRequest, null, [{
    key: 'apiPost',
    value: function apiPost(_ref) {
      var uri = _ref.uri,
          form = _ref.form,
          _ref$auth = _ref.auth,
          auth = _ref$auth === undefined ? false : _ref$auth;


      return new Promise(function (resolve, reject) {

        if (auth) {
          // TODO: Implement common auth to apiPost
        }

        get.concat({
          method: 'POST',
          url: config.server.api + uri,
          form: form,
          json: true
        }, function (err, res, data) {
          if (err) {
            err.message += '\n' + data;
            return reject(err);
          }
          resolve(data);
        });
      });
    }
  }, {
    key: 'cmsAuthHeaders',
    value: function cmsAuthHeaders() {

      return new Promise(function (resolve, reject) {

        var profile = Utils.readProfile();
        if (!profile || !profile.id || !profile.token) {
          console.log('unable to read profile');
          return reject(new Error('unauthorized', 401));
        }
        resolve({
          'x-tidy-user': profile.id,
          'x-tidy-token': profile.token
        });
      });
    }
  }, {
    key: 'cmsGet',
    value: function cmsGet(_ref2) {
      var uri = _ref2.uri,
          _ref2$auth = _ref2.auth,
          auth = _ref2$auth === undefined ? true : _ref2$auth;


      return new Promise(function (resolve, reject) {

        var authPromise = Promise.resolve();
        if (auth) {
          authPromise = TidyRequest.cmsAuthHeaders();
        }
        authPromise.then(function (authHeaders) {
          get.concat({
            method: 'GET',
            url: config.server.cms + uri,
            headers: authHeaders,
            json: true
          }, function (err, res, result) {
            if (err) {
              err.message += '\n' + result;
              return reject(err);
            }
            if (_.hasIn(result, 'success') && result.success === false) {
              return reject(new ApiError(result.message, {
                uri: uri,
                method: 'GET',
                response: result
              }));
            }
            resolve(result);
          });
        }).catch(function (err) {
          reject(err);
        });
      });
    }
  }, {
    key: 'cmsPost',
    value: function cmsPost(_ref3) {
      var uri = _ref3.uri,
          payload = _ref3.payload,
          _ref3$auth = _ref3.auth,
          auth = _ref3$auth === undefined ? true : _ref3$auth;


      return new Promise(function (resolve, reject) {

        var authPromise = Promise.resolve();
        if (auth) {
          authPromise = TidyRequest.cmsAuthHeaders();
        }
        authPromise.then(function (authHeaders) {
          get.concat({
            method: 'POST',
            url: config.server.cms + uri,
            headers: authHeaders,
            body: payload,
            json: true
          }, function (err, res, result) {
            if (err) {
              err.message += '\n' + result;
              return reject(err);
            }
            if (_.hasIn(result, 'success') && result.success === false) {
              return reject(new ApiError(result.message, {
                uri: uri,
                method: 'POST',
                response: result,
                payload: payload
              }));
            }
            resolve(result);
          });
        }).catch(function (err) {
          reject(err);
        });
      });
    }
  }, {
    key: 'profileFile',
    get: function get() {
      return userHome + '/.tidycms';
    }
  }]);

  return TidyRequest;
}();

module.exports = TidyRequest;

/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = require("inquirer");

/***/ }),
/* 12 */
/***/ (function(module, exports) {

module.exports = require("mkdirp");

/***/ }),
/* 13 */
/***/ (function(module, exports) {

module.exports = require("path");

/***/ }),
/* 14 */
/***/ (function(module, exports) {

module.exports = require("simple-get");

/***/ }),
/* 15 */
/***/ (function(module, exports) {

module.exports = require("user-home");

/***/ }),
/* 16 */
/***/ (function(module, exports) {

module.exports = require("util");

/***/ })
/******/ ]);